/// <reference types="node" />
import { IncomingMessage, ClientRequest } from 'http';
import { Context } from '../ctx.provider';
export interface IProxyOptions {
    target: string;
    port?: number;
    followRedirects?: boolean;
    changeOrigin?: boolean;
    timeout?: number;
}
export interface ProxyResponse<T = any> {
    [x: string]: any;
    data: T;
    statusCode: number;
    statusMessage: string;
    headers: any;
    request?: ExtendedClientRequest;
    response?: IncomingMessage;
    toJSON?: () => ProxyResponse<T>;
    message?: string;
}
export interface ProxyResponsePromise<T = any> extends Promise<ProxyResponse<T>> {
}
interface ExtendedClientRequest extends ClientRequest {
    pipes?(ctx: Context): ExtendedClientRequest;
    toPromise?(): ProxyResponsePromise<any>;
}
export declare function createProxy(options: IProxyOptions): (path: string, method: string, headers: any, dataStream?: any) => Promise<{}>;
export {};
