"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function writeHeaders(headers, ctx) {
    const headersMap = {};
    const setCtxHeaders = (field, value) => {
        ctx.set(field, value);
        headersMap[field] = value;
    };
    const setHeader = ctx ? setCtxHeaders : (field, value) => headersMap[field] = value;
    for (const field in headers) {
        if (!Object.prototype.hasOwnProperty.call(headers, field))
            continue;
        const value = headers[field];
        const val = Array.isArray(value) ? value.map(String) : String(value);
        setHeader(String(field).trim(), val);
    }
    return headersMap;
}
exports.writeHeaders = writeHeaders;
